<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>LibGE: src/Mapper.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="cropped-BDS-Logo-1.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibGE
   &#160;<span id="projectnumber">0.31.0</span>
   </div>
   <div id="projectbrief">A c++ GE implementation</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Mapper.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_mapper_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Mapper.h -*- C++ -*-</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef _MAPPER_H_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define _MAPPER_H_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">/* This is an abstract class that cannot be instantiated; it defines the     */</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* most basic characteristics and functionality of a mapper. It is always    */</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">/* composed of both a Genotype and Phenotype structures, and contains a      */</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">/* (private) genotype2phenotype method, that is called everytime a new       */</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">/* genotype is set, and a (private) phenotype2genotype method, that is       */</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">/* called everytime a new phenotype is set.                                  */</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="lib_g_edefs_8h.html">libGEdefs.h</a>&quot;</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_genotype_8h.html">Genotype.h</a>&quot;</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_phenotype_8h.html">Phenotype.h</a>&quot;</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#ifdef GALIB_INCLUDEPATH</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include GALIB_INCLUDEPATH</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#ifndef _ga_ga_h_</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#error ######################################################################</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#error # libGE has been configured to use GALib, but GALib was not found.   #</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#error # Please re-install GALib, or reconfigure libGE and re-install it.   #</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#error # Alternatively, edit the libGEdefs.h file in the include directory. #</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#error ######################################################################</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">using namespace </span>std;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div><div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="class_mapper.html">   33</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_mapper.html">Mapper</a>{</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        <a class="code" href="class_mapper.html">Mapper</a>();</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <a class="code" href="class_mapper.html">Mapper</a>(<span class="keyword">const</span> <a class="code" href="class_genotype.html">Genotype</a> &amp;);</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <a class="code" href="class_mapper.html">Mapper</a>(<span class="keyword">const</span> <a class="code" href="class_phenotype.html">Phenotype</a> &amp;);</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        <a class="code" href="class_mapper.html">Mapper</a>(<span class="keyword">const</span> <a class="code" href="class_mapper.html">Mapper</a>&amp;);</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="keyword">virtual</span> ~<a class="code" href="class_mapper.html">Mapper</a>();</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        <span class="keyword">const</span> <a class="code" href="class_genotype.html">Genotype</a> * getGenotype() <span class="keyword">const</span>;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        <span class="keywordtype">void</span> setGenotype(<span class="keyword">const</span> <a class="code" href="class_genotype.html">Genotype</a> &amp;);</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="preprocessor">#ifdef _ga_ga_h_</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        <span class="comment">//void setGenotype(const GAListGenome&lt;unsigned char&gt; &amp;);</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;<span class="keywordtype">void</span> setGenotype(<span class="keyword">const</span> GA1DArrayGenome&lt;T&gt; &amp;);</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;<span class="keywordtype">void</span> setGenotype(<span class="keyword">const</span> GAListGenome&lt;T&gt; &amp;);</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        <span class="keyword">const</span> <a class="code" href="class_phenotype.html">Phenotype</a> * getPhenotype() <span class="keyword">const</span>;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        <span class="keywordtype">void</span> setPhenotype(<span class="keyword">const</span> <a class="code" href="class_phenotype.html">Phenotype</a> &amp;);</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <span class="keywordtype">void</span> setGenotypeMaxCodonValue(<span class="keyword">const</span> <a class="code" href="_genotype_8h.html#a9950f670ceea0545d1d0a5cf8858ac71">CodonType</a>);</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keyword">protected</span>:</div><div class="line"><a name="l00051"></a><span class="lineno"><a class="line" href="class_mapper.html#a058104ce77afefce7ff10cf98baea52b">   51</a></span>&#160;        <a class="code" href="class_genotype.html">Genotype</a> <a class="code" href="class_mapper.html#a058104ce77afefce7ff10cf98baea52b">genotype</a>;</div><div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="class_mapper.html#adc4c81ef77cc70cda9a1881637bf3bd1">   52</a></span>&#160;        <a class="code" href="class_phenotype.html">Phenotype</a> <a class="code" href="class_mapper.html#adc4c81ef77cc70cda9a1881637bf3bd1">phenotype</a>;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">bool</span> genotype2Phenotype() = 0;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">bool</span> phenotype2Genotype() = 0;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;};</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="preprocessor">#ifdef _ga_ga_h_</span></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="comment">// Sets this mapper&#39;s genotype structure to be a copy of the argument</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="comment">// GA1DArrayGenome structure, and calls the genotype2Phenotype private method.</span></div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_mapper.html#a96e07e87fa2f1f8174c0cc3baa22b965">Mapper::setGenotype</a>(<span class="keyword">const</span> GA1DArrayGenome&lt;T&gt; &amp;genome){</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="preprocessor">        #if (DEBUG_LEVEL &gt;= 1)</span></div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        cerr &lt;&lt; <span class="stringliteral">&quot; Mapper::setGenotype(const GA1DArrayGenome&lt;T&gt; &amp;genome) called.&#39;\n&quot;</span>;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="preprocessor">        #endif</span></div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160; </div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="comment">// Clear contents of current genotype</span></div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    genotype.clear();</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keywordflow">if</span>(genome.size()){</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="comment">// Copy elements of GAGenome onto genotype</span></div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <span class="keywordtype">int</span> ii=0;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="keywordflow">while</span>(ii&lt;genome.size()){</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;            genotype.push_back(genome.gene(ii++));</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        }</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        genotype.setValid(<span class="keyword">true</span>);</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    }</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="comment">// Call genotype2Phenotype</span></div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    genotype2Phenotype();</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;}</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160; </div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="comment">// Sets this mapper&#39;s genotype structure to be a copy of the argument</span></div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="comment">// GAListGenome structure, and calls the genotype2Phenotype private method.</span></div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_mapper.html#a96e07e87fa2f1f8174c0cc3baa22b965">Mapper::setGenotype</a>(<span class="keyword">const</span> GAListGenome&lt;T&gt; &amp;genome){</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="preprocessor">        #if (DEBUG_LEVEL &gt;= 1)</span></div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        cerr &lt;&lt; <span class="stringliteral">&quot;Mapper::setGenotype(const GAListGenome&lt;T&gt; &amp;genome) called. &#39;\n&quot;</span>;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="preprocessor">        #endif</span></div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160; </div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <span class="comment">// Clear contents of current genotype</span></div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    genotype.clear();</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keywordflow">if</span>(genome.size()){</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        <span class="comment">// Cast to non-const, because GALib doesn&#39;t allow</span></div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        <span class="comment">// extraction of elements from const GAList&lt;T&gt;</span></div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        GAListGenome&lt;T&gt; *g=<span class="keyword">const_cast&lt;</span>GAListGenome&lt;T&gt;*<span class="keyword">&gt;</span>(&amp;genome);</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160; </div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        <span class="comment">// Copy elements of GAGenome onto genotype</span></div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        <span class="keywordtype">int</span> ii=0;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160; </div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        <span class="keywordflow">while</span>(ii&lt;genome.size()){</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            <span class="comment">//genotype.push_back(*(genome[ii++]));</span></div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;            genotype.push_back(*(g-&gt;warp(ii++)));</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        }</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        genotype.setValid(<span class="keyword">true</span>);</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160; </div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    }</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160; </div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    <span class="comment">// Call genotype2Phenotype</span></div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    genotype2Phenotype();</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;}</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160; </div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="a_phenotype_8h_html"><div class="ttname"><a href="_phenotype_8h.html">Phenotype.h</a></div></div>
<div class="ttc" id="aclass_phenotype_html"><div class="ttname"><a href="class_phenotype.html">Phenotype</a></div><div class="ttdef"><b>Definition:</b> Phenotype.h:29</div></div>
<div class="ttc" id="aclass_mapper_html_adc4c81ef77cc70cda9a1881637bf3bd1"><div class="ttname"><a href="class_mapper.html#adc4c81ef77cc70cda9a1881637bf3bd1">Mapper::phenotype</a></div><div class="ttdeci">Phenotype phenotype</div><div class="ttdef"><b>Definition:</b> Mapper.h:52</div></div>
<div class="ttc" id="aclass_genotype_html"><div class="ttname"><a href="class_genotype.html">Genotype</a></div><div class="ttdef"><b>Definition:</b> Genotype.h:28</div></div>
<div class="ttc" id="aclass_mapper_html"><div class="ttname"><a href="class_mapper.html">Mapper</a></div><div class="ttdef"><b>Definition:</b> Mapper.h:33</div></div>
<div class="ttc" id="alib_g_edefs_8h_html"><div class="ttname"><a href="lib_g_edefs_8h.html">libGEdefs.h</a></div></div>
<div class="ttc" id="a_genotype_8h_html"><div class="ttname"><a href="_genotype_8h.html">Genotype.h</a></div></div>
<div class="ttc" id="aclass_mapper_html_a96e07e87fa2f1f8174c0cc3baa22b965"><div class="ttname"><a href="class_mapper.html#a96e07e87fa2f1f8174c0cc3baa22b965">Mapper::setGenotype</a></div><div class="ttdeci">void setGenotype(const Genotype &amp;)</div><div class="ttdef"><b>Definition:</b> Mapper.cpp:64</div></div>
<div class="ttc" id="aclass_mapper_html_a058104ce77afefce7ff10cf98baea52b"><div class="ttname"><a href="class_mapper.html#a058104ce77afefce7ff10cf98baea52b">Mapper::genotype</a></div><div class="ttdeci">Genotype genotype</div><div class="ttdef"><b>Definition:</b> Mapper.h:51</div></div>
<div class="ttc" id="a_genotype_8h_html_a9950f670ceea0545d1d0a5cf8858ac71"><div class="ttname"><a href="_genotype_8h.html#a9950f670ceea0545d1d0a5cf8858ac71">CodonType</a></div><div class="ttdeci">int CodonType</div><div class="ttdef"><b>Definition:</b> Genotype.h:24</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
